package pe.so.api.formulario.api;

import org.json.JSONObject;
import pe.so.api.formulario.services.ExcelServices;

import javax.ws.rs.*;
import javax.ws.rs.core.Response;
import javax.ws.rs.ext.Provider;

@Provider
@Path("excel")
@Consumes("application/json")
@Produces("application/json")
public class ExcelApi{
    private final String[] jsonString = {"p_encuesta_id","p_grupo_encuesta","p_correo_alumno","p_unidad_interna_id"};

    private JSONObject MSJ_RESPUESTA = new JSONObject();

    @POST
    @Path("/execute")
    public Response ejecutar(String json) throws Exception {

        JSONObject entrada = new JSONObject(json);
        JSONObject formato = formatoJSON(jsonString);

        if(validarFormato(jsonString,json)){

            ExcelServices excelServices = new ExcelServices();
            MSJ_RESPUESTA = excelServices.execute(entrada);

            return Response.status(200).entity(MSJ_RESPUESTA.toString()).build();
        }else{
            return Response.status(500).entity(
                    MSJ_RESPUESTA.put("status", false)
                            .put("mensaje", "Error en el formato de entrada")
                            .put("formato_esperado", formato).toString()
            ).build();
        }
    }

    private JSONObject formatoJSON (String[] formato){
        JSONObject json = new JSONObject();
        for (String key : formato) {
            json.put(key, "valor");
        }
        return json;
    }

    private boolean validarFormato(String[] formato,String json) {
        JSONObject entrada = new JSONObject(json);
        for (String key : formato) {
            if (!entrada.has(key)) {
                return false;
            }
        }

        return true;
    }
}
