package pe.so.api.formulario.postgresdao;

import org.json.JSONObject;
import pe.so.api.formulario.dao.ExcelDAO;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.Date;

public class PostgreSqlExcel implements ExcelDAO{

    @Override
    public JSONObject execute(JSONObject json) throws Exception{
        JSONObject respuesta = new JSONObject();
        Connection conexion = null;

        try {

            Date date = new Date();
            java.sql.Date sqlDate = new java.sql.Date(date.getTime());
            java.sql.Timestamp sqlTime = new java.sql.Timestamp(date.getTime());

            //private final String[] jsonString = {"p_encuesta_id","p_grupo_encuesta","p_correo_alumno"};

            int p_encuensta_id = json.isNull("p_encuesta_id") ? 0 : json.getInt("p_encuesta_id");
            String p_grupo_encuesta = json.isNull("p_grupo_encuesta") ? "" : json.getString("p_grupo_encuesta");
            String p_correo_alumno = json.isNull("p_correo_alumno") ? "" : json.getString("p_correo_alumno");
            int p_unidad_interna_id = json.isNull("p_unidad_interna_id") ? 0 : json.getInt("p_unidad_interna_id");

            conexion = PostgreSqlFactoryDAO.obtenerConexion("siiaa");

            String sql = "select horario.func_encuesta_procesar_alumno(?,?,?,?)";
            PreparedStatement ps = conexion.prepareStatement(sql);
            ps.setInt(1, p_encuensta_id);
            ps.setString(2, p_grupo_encuesta);
            ps.setString(3, p_correo_alumno);
            ps.setInt(4, p_unidad_interna_id);


            ResultSet rs = ps.executeQuery();

            if (rs.next()) {
                int columnCount = rs.getMetaData().getColumnCount();
                for (int i = 1; i <= columnCount; i++) {
                    respuesta.put(rs.getMetaData().getColumnName(i), rs.getObject(i));
                }
            }
            respuesta.put("status", true);

        } catch (Exception e) {
            respuesta.put("status", false);
            respuesta.put("mensaje", e.getMessage());
        }finally{
            if (conexion != null) {
                conexion.close();
            }
        }
        return respuesta;
    }

}
